
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.PriorityQueue;

public class Task12
{
	public static void main(String[] args) throws IOException
	{
		// načítání
		System.setIn(Files.newInputStream(Paths.get("seq.txt")));
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
//		System.setOut(new PrintStream(Files.newOutputStream(Paths.get("task12.out"))));
		
		// create the stack
		PriorityQueue<Integer> deq = new PriorityQueue<>();
		
		String line;
		while((line = br.readLine()) != null) {
			if(line.startsWith("insert "))
				deq.add(Integer.parseInt(line.substring(7)));
			else
				System.out.println(deq.remove());
		}
	}
}