
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.Deque;
import java.util.LinkedList;

public class Task4
{
	public static void main(String[] args) throws IOException
	{
		// načítání
		System.setIn(Files.newInputStream(Paths.get("seq.txt")));
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
//		System.setOut(new PrintStream(Files.newOutputStream(Paths.get("task4.out"))));
		
		// create the queue
		Deque<Integer> deq = new LinkedList<>();
		
		String line;
		while((line = br.readLine()) != null) {
			if(line.startsWith("insert "))
				deq.addLast(Integer.parseInt(line.substring(7)));
			else
				System.out.println(deq.removeFirst());
		}
	}
}